/* -*- mode: c++; indent-tabs-mode: nil -*- */
/*
    QC_AbstractPollableIoObjectBase.qpp

    AbstractPollableIoObjectBase class definition

    Qore Programming Language

    Copyright (C) 2003 - 2023 Qore Technologies, s.r.o.

    Permission is hereby granted, free of charge, to any person obtaining a
    copy of this software and associated documentation files (the "Software"),
    to deal in the Software without restriction, including without limitation
    the rights to use, copy, modify, merge, publish, distribute, sublicense,
    and/or sell copies of the Software, and to permit persons to whom the
    Software is furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in
    all copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
    FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
    DEALINGS IN THE SOFTWARE.

    Note that the Qore library is released under a choice of three open-source
    licenses: MIT (as above), LGPL 2+, or GPL 2+; see README-LICENSE for more
    information.
*/

#include "qore/Qore.h"
#include "qore/intern/QC_AbstractPollableIoObjectBase.h"
/* Qore class Qore::AbstractPollableIoObjectBase */

qore_classid_t CID_ABSTRACTPOLLABLEIOOBJECTBASE;
QoreClass* QC_ABSTRACTPOLLABLEIOOBJECTBASE;

// AbstractPollableIoObjectBase::constructor() {}
static void AbstractPollableIoObjectBase_constructor(QoreObject* self, const QoreListNode* args, q_rt_flags_t rtflags, ExceptionSink* xsink) {
# 49 "QC_AbstractPollableIoObjectBase.qpp"
xsink->raiseException("INTERNAL-ONLY", "the AbstractPollableIoObjectBase class is not usable by %Qore classes; "
        "inherit a builtin derived class");
}

// int AbstractPollableIoObjectBase::getPollableDescriptor(){}
static QoreValue AbstractPollableIoObjectBase_getPollableDescriptor(QoreObject* self, AbstractPollableIoObjectBase* pollable, const QoreListNode* args, q_rt_flags_t rtflags, ExceptionSink* xsink) {
# 57 "QC_AbstractPollableIoObjectBase.qpp"
    return pollable->getPollableDescriptor();
}

DLLLOCAL void preinitAbstractPollableIoObjectBaseClass() {
    QC_ABSTRACTPOLLABLEIOOBJECTBASE = new QoreClass("AbstractPollableIoObjectBase", "::Qore::AbstractPollableIoObjectBase", QDOM_DEFAULT);
    CID_ABSTRACTPOLLABLEIOOBJECTBASE = QC_ABSTRACTPOLLABLEIOOBJECTBASE->getID();
    QC_ABSTRACTPOLLABLEIOOBJECTBASE->setSystem();
}

DLLLOCAL QoreClass* initAbstractPollableIoObjectBaseClass(QoreNamespace& ns) {
    if (!QC_ABSTRACTPOLLABLEIOOBJECTBASE)
        preinitAbstractPollableIoObjectBaseClass();

    // set parent class
    assert(QC_ABSTRACTPOLLABLEIOOBJECT);
    QC_ABSTRACTPOLLABLEIOOBJECTBASE->addBuiltinVirtualBaseClass(QC_ABSTRACTPOLLABLEIOOBJECT);

    // AbstractPollableIoObjectBase::constructor() {}
    QC_ABSTRACTPOLLABLEIOOBJECTBASE->addConstructor(AbstractPollableIoObjectBase_constructor, Public, QCF_NO_FLAGS, QDOM_DEFAULT);

    // int AbstractPollableIoObjectBase::getPollableDescriptor(){}
    QC_ABSTRACTPOLLABLEIOOBJECTBASE->addMethod("getPollableDescriptor", (q_method_n_t)AbstractPollableIoObjectBase_getPollableDescriptor, Public, QCF_NO_FLAGS, QDOM_DEFAULT, bigIntTypeInfo);

    return QC_ABSTRACTPOLLABLEIOOBJECTBASE;
}
